//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

#include "qgui.h"
#include <allegro.h>
#include <strstream.h>
#include <tdgui.h>
#include <string.h>

QTextBox::QTextBox() {
  text = new ostrstream();
  changed = true;
}

QTextBox::~QTextBox() {
  delete text;
}

void QTextBox::Clear() {
  delete text;
  text = new ostrstream();
  changed = true;
}

int QTextBox::do_QTextBox(int msg, DIALOG* d, int c) {
  return ((QTextBox*)(d->dp2))->doWin(msg, d, c);
}

QTextBox& QTextBox::operator << (char ch) {
  *text << ch;
  changed = true;
  return *this;
}

QTextBox& QTextBox::operator << (const char* str) {
  *text << str;
  changed = true;
  return *this;
}

QTextBox& QTextBox::operator << (short x) {
  *text << x;
  changed = true;
  return *this;
}

QTextBox& QTextBox::operator << (int x) {
  *text << x;
  changed = true;
  return *this;
}

QTextBox& QTextBox::operator << (long x) {
  *text << x;
  changed = true;
  return *this;
}

QTextBox& QTextBox::operator << (double x) {
  *text << x;
  changed = true;
  return *this;
}

QTextBox& QTextBox::operator << (ostrstream* &out) {
  *out << '\0';
  *text << out->str();
  out->freeze(0);
  delete out;
  out = NULL;
  changed = true;
  return *this;
}

int QTextBox::doWin(int msg, DIALOG* d, int c) {
  if ((changed) && (msg == MSG_IDLE)) {
    if (d->dp != NULL)
      delete[] (char*)d->dp;   //trash old text and replace

    if (text->str() == NULL) {
      (char*)d->dp = strdup("");//give an empty string
    } else {
      //Manually copy strings since it isn't NULL terminated
      d->dp = (void*)(new char[text->pcount() + 1]);
      memcpy(d->dp, (void*)text->str(), text->pcount());
      ((char*)(d->dp))[text->pcount()] = '\0';
    }

    text->freeze(0);      //unfreeze

    changed = false;

    //Auto-scrolling
    // *** WARNING *** this statement I had to check the source for both
    // BGUI _AND_ ALLEGRO to make sure it did what I thought this does.  It
    // really only updates the textbox length, so it's okay to call, but
    // remember this is SOURCE DEPENDANT.  This was done so the window was
    // scrolled perfectly w/o being drawn twice and causing lots of flicker.
    d_billtextbox_proc(MSG_START, d, c);
    //the height code comes right out of the Allegro/BGUI source
    d->d2 = d->d1 - ((d->h - 4)/text_height(font));
    if (d->d2 < 0)
      d->d2 = 0;

    //Make sure this gets called
    int ret = d_billtextbox_proc(MSG_IDLE, d, c);
      //Just in case it actually does something in idle
    d_billtextbox_proc(MSG_DRAW, d, c);
      //Just redraw THIS box
    return ret;
  }

  return d_billtextbox_proc(msg, d, c);
}
